library gabepackage;

import 'src/classes.dart';
import 'package:http/http.dart' as http;
import 'package:xml/xml.dart' as xml;
import 'dart:convert';

export 'src/classes.dart';

Future<List<Product>> fetchProducts(List<String> codes) async {
  String username = 'szabo.istvan@techfield.hu';
  String password = 'b2d4e5';

  String basicAuth =
      'Basic ' + base64Encode(utf8.encode('$username:$password'));

  Map<String, String> headers = {
    'content-type': 'application/json',
    'accept': 'application/xml',
    'authorization': basicAuth
  };

  List<String> sanitizedCodes =
  codes.map((f) => f.trim()).where((f) => f.length > 0).toList();

  if (sanitizedCodes.length == 0) {
    throw Exception('Empty list');
  }
  final response = await http.post(
      'http://www.adivhu.hgabka.eu/rendeles-api/keszlet/json',
      headers: headers,
      body: json.encode(sanitizedCodes));

  if (response.statusCode == 200) {
    var document = xml.parse(response.body);
    var errors = document.findAllElements('error');

    if (errors.length > 0) {
      throw Exception(errors.single.text);
    }
    var products = document.findAllElements('product');

    return products
        .map((node) => Product.fromXml({
      'code': node.findElements('product_code').single.text,
      'quantity': int.parse(node.findElements('stock').single.text),
    }))
        .toList();
  } else {
    // If the server did not return a 200 OK response,
    // then throw an exception.
    throw Exception('Nem sikerült az API hívás');
  }
}