class Product {
  int id;
  final String code;
  final int quantity;

  Product({this.code, this.quantity, this.id});

  factory Product.fromXml(Map<String, dynamic> xmlMap) {
    return Product(
      code: xmlMap['code'],
      quantity: xmlMap['quantity'],
    );
  }

  factory Product.fromMap(Map<String, dynamic> map) {
    return Product(
      id: map['id'],
      code: map['code'],
      quantity: map['quantity'],
    );
  }

  // Convert a Project into a Map. The keys must correspond to the names of the
  // columns in the database.
  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'code': code,
      'quantity': quantity,
    };
  }
}
